﻿using Buckets.Logic;

namespace Buckets.Test
{
    [TestClass]
    public class EventTest
    {
        [TestMethod]
        public void FullEvent()
        {
            Bucket bucket = new(200, 100);
            bool didRun = false;
            bucket.Full += (Container container, EventArgs eventArgs) => didRun = true;
            bucket.Fill(100);
            Assert.IsTrue(didRun);
        }

        [TestMethod]
        public void OverflowEvent()
        {
            Bucket bucket = new(200, 100);
            int overflow = 0;
            bucket.Overflowed += (Container container, OverflowEventArgs eventArgs) => overflow = eventArgs.OverflowAmount;
            bucket.Fill(200);
            Assert.AreEqual(100, overflow);
        }
    }
}
